-- file: dynamic.e
-- written by: Vincent Howell
-- date: 11/12/05
-- requires: Euphoria 2.3 or newer
----------------------------------

function scan_file()
    sequence buffer
    object line
    integer fn

    fn = open("temp", "r")

    if fn = -1 then
	clear_screen()
	puts(1, "Error: Could not open temporary file.\n")
	machine_proc(26, 0) -- wait_key
	abort(1)
    end if

    buffer = {}

    while 1 do
	line = gets(fn)

	if atom(line) then
	    exit
	end if

	buffer = append(buffer, line[1..length(line)-1])
    end while

    close(fn)

    return buffer
end function

function dup_check(sequence file)
    sequence scan, dup_files, file_names

    scan = scan_file()
    dup_files = {}
    file_names = {}

    for sloc = 1 to length(scan) do
	for floc = 1 to length(file) do
	    if match(file[floc], scan[sloc]) then
		dup_files = append(dup_files, file[floc])
	    end if
	end for
    end for
    for floc2 = 1 to length(file) do
	if not find(file[floc2], dup_files) and not find(file[floc2], file_names) then
	    file_names = append(file_names, file[floc2])
	end if
    end for

    if equal(dup_files, file) then
	return {}
    else
	return file_names
    end if
end function

global procedure dynamic_include(sequence file)
    sequence cmdLine, includes, includes_copy, scan
    integer fn, fn2

    cmdLine = command_line()
    includes = dup_check(file)
    includes_copy = includes

    if not equal({}, includes) then
	scan = scan_file()

	if not equal({}, scan) then
	    includes = scan & includes
	end if

	fn = open("temp", "a")
	fn2 = open("includes.e", "w")

	for inclC = 1 to length(includes_copy) do
	    puts(fn, includes_copy[inclC] & "\n")
	end for
	for incl = length(includes) to 1 by -1 do
	    puts(fn2, "include \"" & includes[incl] & "\"\n")
	end for

	close(fn)
	close(fn2)

	if platform() = 1 or platform() = 3 then
	    system(cmdLine[1] & " \"" & cmdLine[2] & "\"", 0)
	    abort(0)
	elsif platform() = 2 then
	    system("start " & cmdLine[1] & " \"" & cmdLine[2] & "\"", 0)
	    abort(0)
	end if
    end if
end procedure

global procedure clear_includes()
    integer fn, fn2

    fn = open("includes.e", "w")
    fn2 = open("temp", "w")

    close(fn)
    close(fn2)
end procedure
